#!/usr/bin/perl
########################################################################
#
#	  / (koi8-r)  
#	created by Aleksander Gorohovski (2005). This is free software.
#	angel@feht.dgtu.donetsk.ua

use File::Find;

die "Example usage:\n\t transf <abs_path>\n" if ! @ARGV;

&koi8r;

my $a;
while(! $a){
    @Files=undef;
    
    find sub{push @Files,$File::Find::name if $> == 0 || (stat($File::Find::name))[4] == $>},@ARGV;
    
    $a=1;
    for my $df (@Files){
	my @d=split /\//,$df;
	$t=pop @d;
	while(my($r,$e)=each(%r2e)) {$t=~s/$r/$e/g}
	my $dt=join '/',@d,$t;
	if($df ne $dt){
	    $a=0,print "$df => $dt\n" if ! rename($df,$dt);
	}
    }
}
exit;

sub koi8r{
#   
    %r2e=(
    ""=>'A',	""=>'a',
    ""=>'B',	""=>'b',
    ""=>'V',	""=>'v',
    ""=>'G',	""=>'g',
    ""=>'D',	""=>'d',
    ""=>'E',	""=>'e',
    ""=>'JO',	""=>'jo',
    ""=>'ZH',	""=>'zh',
    ""=>'Z',	""=>'z',
    ""=>'I',	""=>'i',
    ""=>'JJ',	""=>'jj',
    ""=>'K',	""=>'k',
    ""=>'L',	""=>'l',
    ""=>'M',	""=>'m',
    ""=>'N',	""=>'n',
    ""=>'O',	""=>'o',
    ""=>'P',	""=>'p',
    ""=>'R',	""=>'r',
    ""=>'S',	""=>'s',
    ""=>'T',	""=>'t',
    ""=>'U',	""=>'u',
    ""=>'F',	""=>'f',
    ""=>'KH',	""=>'kh',
    ""=>'C',	""=>'c',
    ""=>'CH',	""=>'ch',
    ""=>'SH',	""=>'sh',
    ""=>'SHH',	""=>'shh',
    ""=>'!',	""=>'!',	
#	""=>'"',	""=>'"',	
    ""=>'y',	""=>'y',
    ""=>'\'',	""=>'\'',
    ""=>'eh',	""=>'eh',
    ""=>'ju',	""=>'ju',
    ""=>'ja',	""=>'ja');
}
